program wall_chk;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

var
  fin, fout, fans: textfile;
  so, sa: integer;
  x1, y1, x2, y2: integer;
  n, i, minD: integer;
  x, y, d: integer;
begin
  AssignFile(fin, ParamStr(3)); Reset(fin);
  AssignFile(fans, ParamStr(1)); Reset(fans);
  try
    AssignFile(fout, ParamStr(2)); Reset(fout);

    Read(fout, so);
    Read(fans, sa);
    if (so <> sa) then begin
      Writeln('WRONG! answer: ', sa, ', output: ', so);
      Halt(1);
    end;

    if (so <> -1) then begin
      Read(fout, x1, y1, x2, y2);
      Read(fin, n);
      for i := 0 to n - 1 do begin
        Read(fin, x, y, d);
        if not InRange(x, x1, x2) or not InRange(y, y1, y2) then begin
          WriteLn(
            Format('OOOPS! Point (%d, %d) is not in the rectangle', [x, y]));
          Halt(1);
        end;

        minD := MinIntValue([Abs(x - x1), Abs(x - x2), Abs(y - y1), Abs(y - y2)]);
        if (minD <> d) then begin
          WriteLn(Format(
            'OOOPS! Distance from point (%d, %d) must be %d, but it is %d',
            [x, y, d, minD]));
          Halt(1);
        end;
      end;
    end;
  except on e: Exception do begin
    WriteLn(e.Message);
    Halt(2);
  end;
  end;
  CloseFile(fin);
  CloseFile(fout);
  CloseFile(fans);
end.
